//test for TBK PSG Packer 
//psndcj: 11.02.2012
;compile with sjasmplus
		DEVICE ZXSPECTRUM128

		ORG	#6000
bpl equ $B000
spos equ $B800
sadr equ spos+256
tx equ sadr+512
begin
start:
	ld a,$10,bc,$7ffd:out (c),a
	call	init
	ld a,$17,bc,$7ffd:out (c),a
	ld hl,$5800,de,$5801,bc,767,(hl),$47:ldir
	ld hl,$4000,de,$C000,bc,6912:ldir
;print help
	ld hl,m1
	call tout
	call tout
	call tout
wk:
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,wk
	ld hl,$4000,de,$4001,bc,6143,(hl),l:ldir
;	jr $
;make balls
	ld hl,bpl
	ld a,8
b1:
	push hl
	exa
	ld ix,bs
	ld b,48
b2:
	ld a,(ix+48)
	ld (hl),a
	inc hl
	ld a,(ix+0)
	ld (hl),a
	inc hl
	inc ix
	djnz b2
;roll
	ld ix,bs
	ld b,16
b3:
	xor a
	rr (ix+0)
	rr (ix+1)
	rr (ix+2)
	scf
	rr (ix+48)
	rr (ix+49)
	rr (ix+50)
	inc ix,ix,ix
	djnz b3
	pop hl
	inc h
	exa
	dec a
	jp nz,b1

;copy sin
	ld hl,st,de,spos,bc,256:ldir
;generate vline
	ld hl,sadr
	ld de,$C004
ge1:
	ld (hl),e:inc h
	ld (hl),d:dec h
	call nbde
	inc l
	jr nz,ge1
;form $A000
	ld hl,$A000
	call fila
	ld hl,$A200
	call fila

;create font
	ld c,0
cfo:
	ld a,c
	srl a
	srl a
	srl a
	srl a
	ld l,a,h,0

	ld de,hexf
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	push hl

	ld a,c
	and 15
	ld l,a,h,0

	ld de,hexf
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ex de,hl

	pop hl
	ld b,$90
pu8:
	ld a,(de)
	srl a
	srl a
	srl a
	srl a
	or (hl)
	inc hl,de
	ld (bc),a
	inc b
	ld a,b
	and 7
	jp nz,pu8
	inc c
	jp nz,cfo
;	jr $
loop:
		ei:halt
		ld a,7:out ($FE),a
	ld a,$10,bc,$7ffd:out (c),a
		call	play

pg1: ld a,$17
	ld bc,$7ffd:out (c),a
	xor $0A
	ld (pg1+1),a
	ld (ssp+1),sp
sv1:	ld sp,$A000
	ld c,0

;ERASE BALLS
 dup 16-1
 pop af
 dup 16;erase 1 ball
 pop hl
 ld (hl),c:inc l
 ld (hl),c:inc l
 ld (hl),c
edup;erase 1 ball

edup


 ld a,2:out ($FE),a
; jp calc
;endc:
;CALC X
	ld de,tx
	ld h,spos/256
var1: ld bc,0
	ld a,b
par1:	add a,2
	ld b,a
	ld a,c
par2:	add a,-3
	ld c,a
	ld (var1+1),bc
ca1:
	ld l,c
	ld a,(hl)
	ld l,b
	add a,(hl)
	ld (de),a

	ld a,b
par5:	add a,-4
	ld b,a
	ld a,c
par6:	add a,5
	ld c,a
	
	inc e
	bit 5,e
	jp z,ca1
;CALC Y
	ld de,tx+256
	ld h,spos/256
var2: ld bc,0
	ld a,b
par3:	add a,1
	ld b,a
	ld a,c
par4:	add a,1
	ld c,a
	ld (var2+1),bc
ca2:
	ld l,c
	ld a,(hl)
	ld l,b
	add a,(hl)
	ld (de),a

	ld a,b
par7:	add a,-5
	ld b,a
	ld a,c
par8:	add a,$43
	ld c,a
	
	inc e
	bit 5,e
	jp z,ca2
;CALC TABLES
sv2:	ld hl,$A000
	ld c,0

ca_l:
;X
	ld d,tx/256
	ld e,c
	ld a,(de)
	and 7
	or $B0
	ld (hl),0:inc hl
	ld (hl),a:inc hl
	ld a,(de)
	srl a
	srl a
	srl a
	ld b,a ;X/8
;Y
	inc d
	ld a,(de)
	ld e,a
	ld d,sadr/256
 dup 16;ball adres
	ld a,(de)
	add a,b
	ld (hl),a:inc hl
	inc d
	ld a,(de)
	ld (hl),a:inc hl
	dec d
	inc e
edup;ball adres
	inc c
	ld a,c
	cp 16-1
	jp nz,ca_l

 ld a,1:out ($FE),a

;draw
 di
sv3: ld sp,$A000
 
 dup 16-1;draw 16 balls
 pop hl

 dup 16;draw ball
 	pop de
	ld a,(de):and (hl):inc l:or (hl):inc l:ld (de),a:inc e
	ld a,(de):and (hl):inc l:or (hl):inc l:ld (de),a:inc e
	ld a,(de):and (hl):inc l:or (hl):inc l:ld (de),a
edup;draw ball

edup;draw 16 balls

ssp: ld sp,0

;		ld a,6:out ($FE),a
		ld a,(sv1+2)
		xor 2
		ld (sv1+2),a
		ld (sv2+2),a
		ld (sv3+2),a
;		ld iy,$5C3A
rpoi:		call count;keys
;		ld de,$C000
;		ld hl,par1+1:call prpar
;		ld hl,par2+1:call prpar
;		ld hl,par3+1:call prpar
;		ld hl,par4+1:call prpar
;		ld hl,par5+1:call prpar
;		ld hl,par6+1:call prpar
;		ld hl,par7+1:call prpar
;		ld hl,par8+1:call prpar
		ld a,0:out ($FE),a
		jp	loop
;**********************************************************************************
count:
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,cova
	ld hl,keys,(rpoi+1),hl
	ret
cova: ld bc,20*50
	dec bc
	ld a,b:or c:jp nz,nowai
coptr: ld hl,param_t+8
	call putpar
	ld bc,20*50
	ld a,l:cp param_e&255:jr nz,nowai1
	ld a,h:cp param_e/256:jr nz,nowai1
	ld hl,param_t
nowai1: ld (coptr+1),hl
nowai: ld (cova+1),bc
	ret
param_t:
 db 2,-3,1,1,-4,5,-5,$43
 db 1,1,1,7,3,$10,3,$0E
 db $FD,0,0,1,$10,$12,$40,1
param_e:
putpar:
	ld a,(hl):inc hl:ld (par1+1),a
	ld a,(hl):inc hl:ld (par2+1),a
	ld a,(hl):inc hl:ld (par3+1),a
	ld a,(hl):inc hl:ld (par4+1),a
	ld a,(hl):inc hl:ld (par5+1),a
	ld a,(hl):inc hl:ld (par6+1),a
	ld a,(hl):inc hl:ld (par7+1),a
	ld a,(hl):inc hl:ld (par8+1),a
	ret
;**********************************************************************************
prpar:
	ld l,(hl)
	ld h,$91
 dup 6
 ld a,(hl),(de),a
 inc h,d
edup
	ld d,$C0
	inc e,e
	ret

hexf:incbin "hexd.fnt"

keys:
		ld a,3:out ($FE),a
		ld de,$C000
		ld hl,par1+1:call prpar
		ld hl,par2+1:call prpar
		ld hl,par3+1:call prpar
		ld hl,par4+1:call prpar
		ld hl,par5+1:call prpar
		ld hl,par6+1:call prpar
		ld hl,par7+1:call prpar
		ld hl,par8+1:call prpar

k1:ld a,0
	inc a
	ld (k1+1),a
	and 1
	ret nz
	call keysc
	
	or a:ret z
	ld hl,ktab
	ld c,a
;	ld ixl,0
keyl:
	ld a,(hl):inc hl
	or a:ret z
	inc ixl
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld b,(hl):inc hl
	cp c:jr nz,keyl
;	jr $
	ld a,(de):add a,b:ld (de),a
	ret
ktab:
;increase
	db "Q"
	dw par1+1
	db +1
	db "W"
	dw par2+1
	db +1
	db "E"
	dw par3+1
	db +1
	db "R"
	dw par4+1
	db +1
	db "T"
	dw par5+1
	db +1
	db "Y"
	dw par6+1
	db +1
	db "U"
	dw par7+1
	db +1
	db "I"
	dw par8+1
	db +1
;decrease
	db "1"
	dw par1+1
	db -1
	db "2"
	dw par2+1
	db -1
	db "3"
	dw par3+1
	db -1
	db "4"
	dw par4+1
	db -1
	db "5"
	dw par5+1
	db -1
	db "6"
	dw par6+1
	db -1
	db "7"
	dw par7+1
	db -1
	db "8"
	dw par8+1
	db -1

	db 0

;'Exolon' routine
keysc:
		push	bc
		push	hl
		ld	hl, unk_ACEF
		ld	d, 0FEh

loc_ACD8:
		ld	a, d
		in	a, (0FEh)
		ld	e, 1
		ld	b, 5

loc_ACDF:
		rrca
		jr	nc, loc_ACEB
		inc	hl
		sla	e
		djnz	loc_ACDF
		rlc	d
		jr	c, loc_ACD8

loc_ACEB:
		ld	a, (hl)
		pop	hl
		pop	bc
		ret
; ---------------------------------------------------------------------------
unk_ACEF:	db    1
		db  5Ah	; Z
		db  58h	; X
		db  43h	; C
		db  56h	; V
		db  41h	; A
		db  53h	; S
		db  44h	; D
		db  46h	; F
		db  47h	; G
		db  51h	; Q
		db  57h	; W
		db  45h	; E
		db  52h	; R
		db  54h	; T
		db  31h	; 1
		db  32h	; 2
		db  33h	; 3
		db  34h	; 4
		db  35h	; 5
		db  30h	; 0
		db  39h	; 9
		db  38h	; 8
		db  37h	; 7
		db  36h	; 6
		db  50h	; P
		db  4Fh	; O
		db  49h	; I
		db  55h	; U
		db  59h	; Y
		db  0Dh
		db  4Ch	; L
		db  4Bh	; K
		db  4Ah	; J
		db  48h	; H
		db  20h
		db    2
		db  4Dh	; M
		db  4Eh	; N
		db  42h	; B
		db    0


;calc:
;	exx
;v1:	ld bc,0
;	ld a,b:add a,2:ld b,a
;	ld a,c:add a,-3:ld c,a
;	ld (v1+1),bc
;	ld h,spos/256
;	exx
;	
;v2:	ld bc,0
;	inc b
;	inc c
;	ld (v2+1),bc
;
;	ld h,spos/256
;sv2:	ld de,$A000
;	ld ixh,sadr/256
;
; dup 16-1;16 balls
;;X
;	xor a
;	ld (de),a:inc de
;	exx
;	ld a,c:add a,-4:ld c,a
;	ld a,b:add a,5:ld b,a
;
;	ld l,c
;	ld a,(hl)
;	ld l,b
;	add a,(hl)
;;	inc c
;;	inc c
;;	inc c
;;	dec b
;;	dec b
;;	dec b
;;	dec b
;	exx
;	ld l,a
;;X/8
;	and 7
;	or $B0
;	ld (de),a:inc de
;	ld a,l
;	srl a
;	srl a
;	srl a
;	ld iyl,a
;;Y
;	ld a,c:add a,-$5:ld c,a
;	ld a,b:add a,$43:ld b,a
;
;	ld l,c
;	ld a,(hl)
;	ld l,b
;	add a,(hl)
;;	inc c
;;	inc c
;;	inc c
;;	dec b
;;	dec b
;	ld ixl,a
;
; dup 16
; 	ld a,(ix+0)
; 	add a,iyl
;	ld (de),a:inc de
;	inc ixh
; 	ld a,(ix+0)
;	ld (de),a:inc de
;	dec ixh
;	inc ixl
;edup
;
;edup;16 balls
;	jp endc;ret

fila:
	ld c,16-1
ff1:
	ld (hl),0:inc hl
	ld (hl),$B0:inc hl
	ld de,$C000
	ld b,16
ff2:
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	call nbde
	djnz ff2
	dec c:jr nz,ff1
	ret
	
tout:
	ld e,(hl):inc hl
	ld d,(hl):inc hl
tolp:
	ld a,(hl):inc hl
	or a:ret z
	push hl
	ld l,a
	add hl,hl
	ld h,15
	add hl,hl
	add hl,hl
	
	push de
	ld b,8
ch8:
	ld a,(hl)
	add a,a
	or (hl)
	ld (de),a
;
;	ld a,b
;	cp 5:jp z,msk
;	cp 4:jp nz,nxt
;	ld a,(de):and $55:ld (de),a
;	jr nxt
;msk:
;	ld a,(de):and $aa:ld (de),a
;nxt:
	inc hl
	inc d
	djnz ch8
	pop de
	pop hl
	inc e
	jp tolp
m1:
	dw $4807
	db "g0blinish presents",0

m2:
	dw $482A
	db "BALLMANIA 3",0

m3:
	dw $4849
	db "Press Q-I,1-8",0

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
st:incbin "ballsin.data"
bs:incbin "balls!.bin"
end

	page 0
	org $C000
page0b:
		include "tbkplayer.fast.asm"
PackedPSG:	incbin "acolyte.psg.tpp"
page0e:
;/////////////////////////////////////////////////save snapshot 
		SAVESNA "test.sna",start
;		savebin "ball.code",begin,end-begin
	display end

;-----------------------------------------------------------
 macro	sectors datab,datae

; IF low (datae-datab)=0
;   db 1,5,high (datae-datab)
; ELSE
;   db 1,5,(1+high (datae-datab))
; ENDIF
;
 db 1,5,high (datae-datab+255)
	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM

;test 128K
	ld hl,$FFFF
	ld bc,$7FFD
	ld de,$1011
	out (c),d:ld (hl),d
	out (c),e:ld (hl),e
	out (c),d
	ld a,(hl):cp d:ret nz

 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13

 jp begin


 db "fuckhype"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;+
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29;)
;+128K
	db ":",245 ;:PRINT
	db 34,17,0,16,7,"128K only",34
 db #0D
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "bm3.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "dust.trd","demo.C",begin,end-begin

    PAGE 0
    SAVETRD "dust.trd","pg0.C",page0b,page0e-page0b
;-----------------------------------------------------------
